<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

include_once(PHPWG_ROOT_PATH . 'admin/include/functions_tabsheet.inc.php');
include(get_language_filepath('plugin.lang.php', LOCALEDIT_PATH));

// Vrification de la syntaxe pour du php
function eval_syntax($code)
{
    $code = str_replace(array('<?php', '?>'), '', $code);
    $b = 0;
    foreach (token_get_all($code) as $token) {
        if ('{' == $token) ++$b;
        else if ('}' == $token) --$b;
    }
    if ($b) return false;
    else {
        ob_start();
        $eval = eval('if(0){' . $code . '}');
        ob_end_clean();
        if ($eval === false) return false;
        else return '<?php' . $code . '?>';
    }
}

// Gestion des onglets
if (!isset($_GET['tab']))
    $page['tab'] = 'localconf';
else
    $page['tab'] = $_GET['tab'];

$my_base_url = get_admin_plugin_menu_link(__FILE__);

$page['tabsheet'] = array(
    'localconf' => array('caption' => l10n('locfiledit_onglet_localconf'), 'url' => add_url_params($my_base_url, array('tab' => 'localconf'))),
    'css' => array('caption' => l10n('locfiledit_onglet_css'), 'url' => add_url_params($my_base_url, array('tab' => 'css'))),
    'tpl' => array('caption' => l10n('locfiledit_onglet_tpl'), 'url' => add_url_params($my_base_url, array('tab' => 'tpl'))),
    'lang' => array('caption' => l10n('locfiledit_onglet_lang'), 'url' => add_url_params($my_base_url, array('tab' => 'lang'))),
    'plug' => array('caption' => l10n('locfiledit_onglet_plug'), 'url' => add_url_params($my_base_url, array('tab' => 'plug'))));

$page['tabsheet'][$page['tab']]['selected'] = true;
template_assign_tabsheet();

// Initialisation des variables
$edited_file = '';
$content_file = '';
$new_file['localconf'] = "<?php\n\n" . l10n('locfiledit_newfile') . "\n\n\n\n\n?>";
$new_file['css'] = l10n('locfiledit_newfile') . "\n\n";
$new_file['lang'] = "<?php\n\n" . l10n('locfiledit_newfile') . "\n\n\n\n\n?>";
$new_file['plug'] = "<?php\n/*
Plugin Name: " . l10n('locfiledit_onglet_plug') . "
Version: 1.0
Description: " . l10n('locfiledit_onglet_plug') . "
Plugin URI: http://www.phpwebgallery.net
Author:
Author URI:
*/\n\n\n\n\n?>";

// Editarea options
$editarea = array(
  'start_highlight' => 'true',
  'language' => '"'.substr($user['language'], 0, 2).'"',
  'toolbar' => '"search,fullscreen, |,select_font, |, undo, redo, change_smooth_selection, highlight, reset_highlight, |, help"');
if (isset($conf['editarea_options']) and is_array($conf['editarea_options']))
{
  $editarea = array_merge($editarea, $conf['editarea_options']);
}

// Edition du fichier slectionn (CSS, Template, Langue)
if ((isset($_POST['edit'])) and (!empty($_POST['file_to_edit']))) {
    $edited_file = $_POST['file_to_edit'];
    if (file_exists($edited_file)) {
        $content_file = file_get_contents($edited_file);
    } else $content_file = $new_file[$page['tab']];
}

// Edition du config_local.inc.php
if ($page['tab'] == 'localconf') {
    $edited_file = PHPWG_ROOT_PATH . "include/config_local.inc.php";
    if (!file_exists($edited_file)) $content_file = $new_file['localconf'];
    else $content_file = file_get_contents($edited_file);
    $template->assign_block_vars('show_default' , array(
        'SHOW_DEFAULT' => LOCALEDIT_PATH . 'show_default.php?file=include/config_default.inc.php',
        'FILE' => 'config_default.inc.php'));
    $editarea['syntax'] = '"php"';
}

// Edition du plugin perso
if ($page['tab'] == 'plug') {
    $edited_file = PHPWG_PLUGINS_PATH . "PersonalPlugin/main.inc.php";
    if (!is_dir(PHPWG_PLUGINS_PATH . "PersonalPlugin")) mkdir(PHPWG_PLUGINS_PATH . "PersonalPlugin", 0777);
    if (!file_exists($edited_file)) $content_file = $new_file['plug'];
    else $content_file = file_get_contents($edited_file);
    $editarea['syntax'] = '"php"';
}

// Menu droulant des CSS
if ($page['tab'] == 'css') {
    $template->assign_block_vars('css_lang_tpl.template_option',
        array('VALUE' => '',
            'CONTENT' => $lang['locfiledit_choose_file']));
    $template->assign_block_vars('css_lang_tpl.template_option',
        array('VALUE' => '',
            'CONTENT' => '----------------------'));
    $value = PHPWG_ROOT_PATH . "template-common/local-layout.css";
    $edited_file == $value ? $selected = 'selected="selected"' : $selected = '';
    $template->assign_block_vars('css_lang_tpl.template_option',
        array('VALUE' => $value,
            'CONTENT' => 'template-common / local-layout.css',
            'SELECTED' => $selected,
            ));
    $template_dir = PHPWG_ROOT_PATH . 'template';
    foreach (get_dirs($template_dir) as $pwg_template) {
        $value = $template_dir . '/' . $pwg_template . '/local-layout.css';
        $edited_file == $value ? $selected = 'selected="selected"' : $selected = '';
        $template->assign_block_vars('css_lang_tpl.template_option',
            array('VALUE' => '',
                'CONTENT' => '----------------------'
                ));
        $template->assign_block_vars('css_lang_tpl.template_option',
            array('VALUE' => $value,
                'CONTENT' => $pwg_template . ' / local-layout.css',
                'SELECTED' => $selected,
                ));
        $template->assign_block_vars('css_lang_tpl.template_option',
            array('VALUE' => '',
                'CONTENT' => '----------------------'
                ));
        foreach (get_dirs($template_dir . '/' . $pwg_template . '/theme') as $theme) {
            $value = $template_dir . '/' . $pwg_template . '/theme/' . $theme . '/theme.css';
            $edited_file == $value ? $selected = 'selected="selected"' : $selected = '';
            $template->assign_block_vars('css_lang_tpl.template_option',
                array('VALUE' => $value,
                    'CONTENT' => $pwg_template . ' / ' . $theme . ' / theme.css',
                    'SELECTED' => $selected));
        }
    }
    $editarea['syntax'] = '"css"';
}

// Menu droulant des templates
if ($page['tab'] == 'tpl') {
    $template->assign_block_vars('css_lang_tpl.template_option',
        array('VALUE' => '',
            'CONTENT' => $lang['locfiledit_choose_file']));
    $template_dir = PHPWG_ROOT_PATH . 'template';
    foreach (get_dirs($template_dir) as $pwg_template) {
        $template->assign_block_vars('css_lang_tpl.template_option',
            array('VALUE' => '',
                'CONTENT' => '----------------------'));
        $dir = $template_dir . '/' . $pwg_template . '/';
        if (is_dir($dir) and $content = opendir($dir)) {
            while ($node = readdir($content)) {
                if (is_file($dir . $node) and strtolower(get_extension($node)) == 'tpl' and !strpos($node , '.bak.tpl')) {
                    $value = $dir . $node;
                    $edited_file == $value ? $selected = 'selected="selected"' : $selected = '';
                    $template->assign_block_vars('css_lang_tpl.template_option',
                        array('VALUE' => $value,
                            'CONTENT' => $pwg_template . ' / ' . $node,
                            'SELECTED' => $selected));
                }
            }
        }
    }
    $editarea['syntax'] = '"html"';
}

// Menu droulant des fichiers langues
if ($page['tab'] == 'lang') {
    $template->assign_block_vars('css_lang_tpl.template_option',
        array('VALUE' => '',
            'CONTENT' => $lang['locfiledit_choose_file'],
            ));
    $template->assign_block_vars('css_lang_tpl.template_option',
        array('VALUE' => '',
            'CONTENT' => '----------------------'));
    foreach (get_languages() as $language_code => $language_name) {
        $value = PHPWG_ROOT_PATH . 'language/' . $language_code . '/local.lang.php';
        if ($edited_file == $value) {
            $selected = 'selected="selected"';
            $template->assign_block_vars('show_default' , array('SHOW_DEFAULT' => LOCALEDIT_PATH . 'show_default.php?file=' . 'language/' . $language_code . '/common.lang.php',
                    'FILE' => 'common.lang.php'));
            $template->assign_block_vars('show_default' , array('SHOW_DEFAULT' => LOCALEDIT_PATH . 'show_default.php?file=' . 'language/' . $language_code . '/admin.lang.php',
                    'FILE' => 'admin.lang.php'));
        } else $selected = '';
        $template->assign_block_vars('css_lang_tpl.template_option',
            array('VALUE' => $value,
                'CONTENT' => $language_name,
                'SELECTED' => $selected));
    }
    $editarea['syntax'] = '"php"';
}

// Chargement du fichier de sauvegarde
if (isset($_POST['restore'])) {
    $edited_file = $_POST['edited_file'];;
    $content_file = file_get_contents(substr_replace($edited_file , '.bak' , strrpos($edited_file , '.') , 0));
    array_push($page['infos'], l10n('locfiledit_bak_loaded1'), l10n('locfiledit_bak_loaded2'));
}

// Enregistrement du fichier
if (isset($_POST['submit'])) {
    $edited_file = $_POST['edited_file'];
    $content_file = stripslashes($_POST['text']);
    if (get_extension($edited_file) == 'php') {
        $content_file = eval_syntax($content_file);
    }
    if ($content_file === false) {
        array_push($page['errors'], l10n('locfiledit_syntax_error'));
    } else {
        if ((!file_exists($edited_file) or (@copy($edited_file , substr_replace($edited_file , '.bak' , strrpos($edited_file , '.') , 0))))
                and $file = @fopen($edited_file , "w")) {
            fwrite($file , $content_file);
            fclose($file);
            array_push($page['infos'], l10n('locfiledit_save_config'),
                sprintf(l10n('locfiledit_saved_bak') , substr(substr_replace($edited_file , '.bak' , strrpos($edited_file , '.') , 0), 2)));
        } else array_push($page['errors'], l10n('locfiledit_cant_save'));
    }
}

// Affichage de la zone d'dition
if (!empty($edited_file)) {
    if (!empty($page['errors'])) {
        $content_file = stripslashes($_POST['text']);
    }
    $template->assign_block_vars('zone_edit',
        array('EDITED_FILE' => $edited_file,
            'CONTENT_FILE' => str_replace('<', '&lt;', $content_file),
            'FILE_NAME' => substr($edited_file, 2)));
    if (file_exists(substr_replace($edited_file , '.bak' , strrpos($edited_file , '.') , 0)))
        $template->assign_block_vars('zone_edit.restore', array());
}

// Editarea
if (!isset($conf['editarea_options']) or $conf['editarea_options'] !== false)
{
  $template->assign_block_vars('editarea', array('EDITAREA_URL' => LOCALEDIT_PATH . 'editarea/edit_area_full.js'));
  foreach($editarea as $option => $value)
  {
    $template->assign_block_vars('editarea.options',
      array('OPTION' => $option,
            'VALUE' => $value));
  }
}

// Paramtrage du template
$template->set_filename('plugin_admin_content', LOCALEDIT_PATH . 'admin.tpl');
$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');

?>